var fs = require('fs');
var orchestra = require('orchestra');
var testCase = require('nodeunit').testCase;

module.exports = testCase({
  setUp: function (callback) {
    this.orchestraing = new orchestra();
    callback();
  },

  'it should emit to orchestra using emitter': function (test) {
		this.orchestraing.on('geocode1', function(data) {
      test.ok(data !== null);
      test.done();
		});
    fs.readFile('/etc/passwd' , this.orchestraing.emitter("geocode1"));
  },
  
  'it should emit both events using emitter': function(test) {
		this.orchestraing.on('geocode1,geocode2', function(data) {
      test.ok(data !== null);
      test.done();
		});
    
		fs.readFile('/etc/passwd', this.orchestraing.emitter("geocode1"));
		fs.stat('/etc/passwd', this.orchestraing.emitter("geocode2"));
  },

  'it should emit to orchestra using emit': function (test) {
    var self = this;
		this.orchestraing.on('geocode1', function(data) {
      test.ok(data !== null);
      test.done();
		});
    fs.readFile('/etc/passwd', function(err, data) {
      self.orchestraing.emit("geocode1", data);
    });
  },
  
  'it should emit both events using emit': function(test) {
    var self = this;
		this.orchestraing.on('geocode1,geocode2', function(data) {
      test.ok(data !== null);
      test.done();
		});

    fs.readFile('/etc/passwd', function(err, data) {
      self.orchestraing.emit("geocode1", data);
    });

    fs.stat('/etc/passwd', function(err, data) {
      self.orchestraing.emit("geocode2", data);
    });
  }
});
